(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@ibm-wch-sdk/ng-api'), require('@angular/core'), require('typescript-logging')) :
    typeof define === 'function' && define.amd ? define('@ibm-wch-sdk/typescript-logger', ['exports', '@angular/common', '@ibm-wch-sdk/ng-api', '@angular/core', 'typescript-logging'], factory) :
    (factory((global['ibm-wch-sdk'] = global['ibm-wch-sdk'] || {}, global['ibm-wch-sdk']['typescript-logger'] = {}),global.ng.common,global['@ibm-wch-sdk/ng-api'],global.ng.core,global.typescriptLogging));
}(this, (function (exports,common,ngApi,core,typescriptLogging) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TypescriptLoggerService = /** @class */ (function () {
        function TypescriptLoggerService() {
        }
        /**
         * @param {?} name
         * @return {?}
         */
        TypescriptLoggerService.prototype.create = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var cat = new typescriptLogging.Category(name);
                /**
                 * @param {?} msg
                 * @param {...?} data
                 * @return {?}
                 */
                function info(msg) {
                    var data = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        data[_i - 1] = arguments[_i];
                    }
                    // dispatch to the category
                    cat.info({ msg: msg, data: data });
                }
                /**
                 * @param {?} msg
                 * @param {...?} data
                 * @return {?}
                 */
                function error(msg) {
                    var data = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        data[_i - 1] = arguments[_i];
                    }
                    // dispatch to the category
                    cat.error(msg, new Error(msg));
                }
                /**
                 * @param {?} msg
                 * @param {...?} data
                 * @return {?}
                 */
                function warn(msg) {
                    var data = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        data[_i - 1] = arguments[_i];
                    }
                    // dispatch to the category
                    cat.warn({ msg: msg, data: data });
                }
                return { info: info, error: error, warn: warn };
            };
        TypescriptLoggerService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        TypescriptLoggerService.ctorParameters = function () { return []; };
        return TypescriptLoggerService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WchTypescriptLoggingModule = /** @class */ (function () {
        /*
         * This contructor prevents the module from being imported multiple times.
         *
         * @param parentModule
         */
        function WchTypescriptLoggingModule(parentModule) {
            // do not allow recursive includes
            if (parentModule) {
                throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
            }
        }
        /*
         * Returns the preconfigured module
         *
         * @param aService  the service
         */
        /*
           * Returns the preconfigured module
           *
           * @param aService  the service
           */
        /**
         * @return {?}
         */
        WchTypescriptLoggingModule.forRoot = /*
           * Returns the preconfigured module
           *
           * @param aService  the service
           */
            /**
             * @return {?}
             */
            function () {
                return {
                    ngModule: WchTypescriptLoggingModule,
                    providers: [
                        { provide: ngApi.WchLoggerFactory, useClass: TypescriptLoggerService }
                    ]
                };
            };
        WchTypescriptLoggingModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule]
                    },] }
        ];
        /** @nocollapse */
        WchTypescriptLoggingModule.ctorParameters = function () {
            return [
                { type: WchTypescriptLoggingModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
            ];
        };
        return WchTypescriptLoggingModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ɵa = ngApi.WchLoggerFactory;
    exports.WchTypescriptLoggingModule = WchTypescriptLoggingModule;
    exports.ɵb = TypescriptLoggerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ibm-wch-sdk-typescript-logger.umd.js.map